Help us improve by taking our short survey: https://www.hdfgroup.org/website-survey/

| HDF5 Last Updated on 2026-07-28 The HDF5 Field Guide

Loading...
Searching...
No Matches
FileCreatPropList Class Reference

`#include <c++/src/H5FcreatProp.h>`

## Detailed Description

Class FileCreatPropList inherits from PropList and provides wrappers for the HDF5 file create property list.

Inheritance diagram for FileCreatPropList:

## Public Member Functions
| FileCreatPropList ()
| Default constructor: Creates a file create property list.
| FileCreatPropList (const FileCreatPropList &orig)
| Copy constructor: same HDF5 object as original FileCreatPropList object.
| FileCreatPropList (const hid_t plist_id)
| Creates a file creation property list using the id of an existing one.
virtual std::string | fromClass () const override
| Returns this class name.
hsize_t | getFileSpacePagesize () const
| Returns the file space page size for aggregating small metadata or raw data.
void | getFileSpaceStrategy (H5F_fspace_strategy_t &strategy, bool &persist, hsize_t &threshold) const
| Retrieves the strategy, persist, and threshold that the library uses in managing file space.
unsigned | getIstorek () const
| Returns the 1/2 rank of an indexed storage B-tree.
void | getSizes (size_t &sizeof_addr, size_t &sizeof_size) const
| Retrieves the size of the offsets and lengths used in an HDF5 file.
void | getSymk (unsigned &int_nodes_k, unsigned &leaf_nodes_k) const
| Retrieves the size of the symbol table B-tree 1/2 rank and the symbol table leaf node 1/2 size.
hsize_t | getUserblock () const
| Returns the user block size of this file creation property list.
void | getVersion (unsigned &super, unsigned &freelist, unsigned &stab, unsigned &shhdr) const
| Retrieves version information for various parts of a file.
void | setFileSpacePagesize (hsize_t fsp_psize) const
| Sets the file space page size for paged aggregation.
void | setFileSpaceStrategy (H5F_fspace_strategy_t strategy, bool persist, hsize_t threshold) const
| Sets the strategy and the threshold value that the library will employ in managing file space.
void | setIstorek (unsigned ik) const
| Sets the size of the parameter used to control the B-trees for indexing chunked datasets.
void | setSizes (size_t sizeof_addr=4, size_t sizeof_size=4) const
| Sets the byte size of the offsets and lengths used to address objects in an HDF5 file.
void | setSymk (unsigned int_nodes_k, unsigned leaf_nodes_k) const
| Sets the size of parameters used to control the symbol table nodes.
void | setUserblock (hsize_t size) const
| Sets the user block size field of this file creation property list.
virtual | ~FileCreatPropList () override=default
Public Member Functions inherited from PropList
virtual void | close () override
| Closes the property list if it is not a default one.
void | closeClass () const
| Close a property list class.
void | copy (const PropList &like_plist)
| Makes a copy of an existing property list.
void | copyProp (PropList &dest, const char *name) const
| Copies a property from this property list or class to another.
void | copyProp (PropList &dest, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | copyProp (PropList &dest, PropList &src, const char *name) const
| Copies a property from one list or class to another - Obsolete.
void | copyProp (PropList &dest, PropList &src, const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts. - Obsolete.
hid_t | getClass () const
| Returns the class of this property list, i.e. `H5P_FILE_CREATE`...
std::string | getClassName () const
| Return the name of a generic property list class.
PropList | getClassParent () const
| Returns the parent class of a generic property class.
virtual hid_t | getId () const override
| Get the id of this property list.
size_t | getNumProps () const
| Returns the number of properties in this property list or class.
std::string | getProperty (const char *name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const char *name, void *value) const
| Query the value of a property in a property list.
std::string | getProperty (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | getProperty (const std::string &name, void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
size_t | getPropSize (const char *name) const
| Query the size of a property in a property list or class.
size_t | getPropSize (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
bool | isAClass (const PropList &prop_class) const
| Determines whether a property list is a certain class.
PropList & | operator= (const PropList &rhs)
| Assignment operator.
bool | operator== (const PropList &rhs) const
| Compares this property list or class against the given list or class.
bool | propExist (const char *name) const
| Query the existence of a property in a property object.
bool | propExist (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
| PropList ()
| Default constructor: creates a stub property list object.
| PropList (const hid_t plist_id)
| Creates a property list using the id of an existing property.
| PropList (const PropList &original)
| Copy constructor: same HDF5 object as original.
void | removeProp (const char *name) const
| Removes a property from a property list.
void | removeProp (const std::string &name) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const char *charptr) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const char *name, const void *value) const
| Set a property's value in a property list.
void | setProperty (const char *name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const char *name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, const std::string &strg) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, const void *value) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what arguments it accepts.
void | setProperty (const std::string &name, std::string &strg) const
| Deprecated due to missing const in prototype. (1.10.1).
void | setProperty (const std::string &name, void *value) const
| Deprecated due to missing const in prototype. (1.10.1).
virtual | ~PropList () override
| Properly terminates access to this property list.
Public Member Functions inherited from IdComponent
void | decRefCount () const
| Decrement reference counter for the id of this object.
void | decRefCount (const hid_t obj_id) const
| Decrement reference counter for a given id.
int | getCounter () const
| Returns the reference counter for the id of this object.
int | getCounter (const hid_t obj_id) const
| Returns the reference counter for a given id.
H5I_type_t | getHDFObjType () const
| Returns the type of the object. It is an overloaded function of the above function.
void | incRefCount () const
| Increment reference counter for the id of this object.
void | incRefCount (const hid_t obj_id) const
| Increment reference counter for a given id.
std::string | inMemFunc (const char *func_name) const
| Makes and returns string "<class-name>::<func_name>".
IdComponent & | operator= (const IdComponent &rhs)
| Assignment operator.
void | setId (const hid_t new_id)
| Sets the identifier of this object to a new value.
virtual | ~IdComponent ()=default

## Static Public Member Functions
static void | deleteConstants ()
Static Public Member Functions inherited from PropList
static void | deleteConstants ()
Static Public Member Functions inherited from IdComponent
static H5I_type_t | getHDFObjType (const hid_t obj_id)
| Given an id, returns the type of the object.
static hsize_t | getNumMembers (H5I_type_t type)
| Returns the number of members of the given type.
static bool | isValid (hid_t an_id)
| Checks if the given ID is valid.
static bool | typeExists (H5I_type_t type)
| Queries if a given type is currently registered with the library.

## Static Public Attributes
static const FileCreatPropList & | DEFAULT = *getConstant()
| Default file creation property list.
Static Public Attributes inherited from PropList
static const PropList & | DEFAULT = *getConstant()
| Default property list.

## Additional Inherited Members
Protected Member Functions inherited from PropList
virtual void | p_setId (const hid_t new_id) override
| Sets the identifier of this object to a new value.
Protected Member Functions inherited from IdComponent
| IdComponent ()
| Default constructor.
std::string | p_get_file_name () const
Static Protected Member Functions inherited from IdComponent
static bool | p_valid_id (const hid_t obj_id)
Protected Attributes inherited from PropList
hid_t | id
Static Protected Attributes inherited from IdComponent
static bool | H5dontAtexit_called = false

## Constructor & Destructor Documentation

## ◆ FileCreatPropList() [1/3]

FileCreatPropList | ( |  | ) |

Default constructor: Creates a file create property list.

## ◆ FileCreatPropList() [2/3]

FileCreatPropList | ( | const FileCreatPropList & | original | ) |

Copy constructor: same HDF5 object as original FileCreatPropList object.

Parameters

  original | - IN: FileCreatPropList instance to copy

## ◆ FileCreatPropList() [3/3]

FileCreatPropList | ( | const hid_t | plist_id | ) |

Creates a file creation property list using the id of an existing one.

Parameters

  plist_id | - IN: FileCreatPropList id to use

## ◆ ~FileCreatPropList()

virtual ~FileCreatPropList | ( |  | ) |
| override virtual default

## Member Function Documentation

## ◆ deleteConstants()

void deleteConstants | ( |  | ) |
| static

## ◆ fromClass()

virtual std::string fromClass | ( |  | ) | const
| override virtual

Returns this class name.

Reimplemented from PropList.

## ◆ getFileSpacePagesize()

hsize_t getFileSpacePagesize | ( |  | ) | const

Returns the file space page size for aggregating small metadata or raw data.

Returns
  File space page size

Exceptions

  H5::PropListIException |

## ◆ getFileSpaceStrategy()

void getFileSpaceStrategy | ( | H5F_fspace_strategy_t & | strategy,
|  | bool & | persist,
|  | hsize_t & | threshold ) const

Retrieves the strategy, persist, and threshold that the library uses in managing file space.

Parameters

  strategy | - OUT: Strategy for file space management
  persist | - OUT: Whether to persist free-space
  threshold | - OUT: Free-space section threshold

Exceptions

  H5::PropListIException |

## ◆ getIstorek()

unsigned getIstorek | ( |  | ) | const

Returns the 1/2 rank of an indexed storage B-tree.

Returns
  1/2 rank of chunked storage B-tree

Exceptions

  H5::PropListIException |

Description
  For information, please refer to the H5Pget_istore_k API in the HDF5 C Reference Manual.

## ◆ getSizes()

void getSizes | ( | size_t & | sizeof_addr,
|  | size_t & | sizeof_size ) const

Retrieves the size of the offsets and lengths used in an HDF5 file.

Exceptions

  H5::PropListIException |

## ◆ getSymk()

void getSymk | ( | unsigned & | ik,
|  | unsigned & | lk ) const

Retrieves the size of the symbol table B-tree 1/2 rank and the symbol table leaf node 1/2 size.

Exceptions

  H5::PropListIException |

Description
  For information, please refer to the H5Pget_sym_k API in the HDF5 C Reference Manual.

## ◆ getUserblock()

hsize_t getUserblock | ( |  | ) | const

Returns the user block size of this file creation property list.

Returns
  User block size

Exceptions

  H5::PropListIException |

## ◆ getVersion()

void getVersion | ( | unsigned & | super,
|  | unsigned & | freelist,
|  | unsigned & | stab,
|  | unsigned & | shhdr ) const

Retrieves version information for various parts of a file.

Parameters

  super | - OUT: The file super block.
  freelist | - OUT: The global free list.
  stab | - OUT: The root symbol table entry.
  shhdr | - OUT: Shared object headers.

Exceptions

  H5::PropListIException |

Description
  Any (or even all) of the output arguments can be null pointers.

## ◆ setFileSpacePagesize()

void setFileSpacePagesize | ( | hsize_t | fsp_psize | ) | const

Sets the file space page size for paged aggregation.

Parameters

  fsp_psize | - IN: Filespace's page size

Exceptions

  H5::PropListIException |

## ◆ setFileSpaceStrategy()

void setFileSpaceStrategy | ( | H5F_fspace_strategy_t | strategy,
|  | bool | persist,
|  | hsize_t | threshold ) const

Sets the strategy and the threshold value that the library will employ in managing file space.

Parameters

  strategy | - IN: Strategy for file space management
  persist | - IN: Whether to persist free-space
  threshold | - IN: Free-space section threshold. The library default is 1, which is to track all free-space sections.

Exceptions

  H5::PropListIException |

Description
  If the given strategy is zero, the property will not be changed and the existing strategy will be retained. If the given threshold value is zero, the property will not be changed and the existing threshold will be retained. For information, please refer to the H5Pset_file_space_strategy API in the HDF5 C Reference Manual.

## ◆ setIstorek()

void setIstorek | ( | unsigned | ik | ) | const

Sets the size of the parameter used to control the B-trees for indexing chunked datasets.

Parameters

  ik | - IN: 1/2 rank of chunked storage B-tree

Exceptions

  H5::PropListIException |

Description
  For information, please refer to the H5Pset_istore_k API in the HDF5 C Reference Manual.

## ◆ setSizes()

void setSizes | ( | size_t | sizeof_addr = 4,
|  | size_t | sizeof_size = 4 ) const

Sets the byte size of the offsets and lengths used to address objects in an HDF5 file.

Parameters

  sizeof_addr | - IN: Size of an object offset in bytes
  sizeof_size | - IN: Size of an object length in bytes.

Exceptions

  H5::PropListIException |

Description
  For information, please refer to the H5Pset_sizes API in the HDF5 C Reference Manual.

## ◆ setSymk()

void setSymk | ( | unsigned | ik,
|  | unsigned | lk ) const

Sets the size of parameters used to control the symbol table nodes.

Parameters

  ik | - IN: Symbol table tree rank
  lk | - IN: Symbol table node size

Exceptions

  H5::PropListIException |

Description
  For information, please refer to the H5Pset_sym_k API in the HDF5 C Reference Manual.

## ◆ setUserblock()

void setUserblock | ( | hsize_t | size | ) | const

Sets the user block size field of this file creation property list.

Parameters

  size | - IN: User block size to be set, in bytes

Exceptions

  H5::PropListIException |

Description
  The default user block size is 0; it may be set to any power of 2 equal to 512 or greater (512, 1024, 2048, etc.)

## Field Documentation

## ◆ DEFAULT

const FileCreatPropList & DEFAULT = *getConstant()
| static

Default file creation property list.

The documentation for this class was generated from the following files:

- c++/src/H5FcreatProp.h
- c++/src/H5FcreatProp.cpp